#ifndef GGAFDXCORE_GGAFDXPROPERTIES_H_
#define GGAFDXCORE_GGAFDXPROPERTIES_H_
#include "GgafDxCommonHeader.h"
#include "jp/ggaf/core/GgafProperties.h"

#ifdef PROPERTY
    #undef PROPERTY
#endif
#define PROPERTY GgafDxCore::GgafDxProperties

namespace GgafDxCore {

class GgafDxProperties: public GgafCore::GgafProperties {
public:
    /** [r] tXN[[hł邩ǂ */
    static bool FULL_SCREEN;
    /** [r] Qʃ[hł邩ǂ */
    static bool DUAL_VIEW;
    /** [r] Q[ԗ̈敝̊l */
    static pixcoord GAME_BUFFER_WIDTH;
    /** [r] Q[ԗ̈捂l */
    static pixcoord GAME_BUFFER_HEIGHT;
    /** [r] Q[ԗ̈[̊l */
    static double GAME_SPACE_DEPTH;
    /** [r] ˉeϊ𐳎ˉeōsꍇtrueBftHgfalse */
    static bool PRJ_2D_MODE;
    /** [r] `T[tFCX̃sNZTCY */
    static pixcoord RENDER_TARGET_BUFFER_WIDTH;
    /** [r] `T[tFCX̃sNZTCY */
    static pixcoord RENDER_TARGET_BUFFER_HEIGHT;
    /** [r] PʃEBhE[hꍇ̃EBhȄTCY */
    static pixcoord SINGLE_VIEW_WINDOW_WIDTH;
    /** [r] PʃEBhE[hꍇ̃EBhȄTCY */
    static pixcoord SINGLE_VIEW_WINDOW_HEIGHT;
    /** [r] QʃEBhE[hꍇ̂Pʖڂ̃EBhȄTCY */
    static pixcoord DUAL_VIEW_WINDOW1_WIDTH;
    /** [r] QʃEBhE[hꍇ̂Pʖڂ̃EBhȄTCY */
    static pixcoord DUAL_VIEW_WINDOW1_HEIGHT;
    /** [r] QʃEBhE[hꍇ̂Qʖڂ̃EBhȄTCY */
    static pixcoord DUAL_VIEW_WINDOW2_WIDTH;
    /** [r] QʃEBhE[hꍇ̂Qʖڂ̃EBhȄTCY */
    static pixcoord DUAL_VIEW_WINDOW2_HEIGHT;
    /** [r] PʃtXN[[hꍇ̃XN[̉𑜓x() */
    static pixcoord SINGLE_VIEW_FULL_SCREEN_WIDTH;
    /** [r] PʃtXN[[hꍇ̃XN[̉𑜓x(c) */
    static pixcoord SINGLE_VIEW_FULL_SCREEN_HEIGHT;
    /** [r] QʃtXN[[hꍇ̂PʖڃXN[̉𑜓x() */
    static pixcoord DUAL_VIEW_FULL_SCREEN1_WIDTH;
    /** [r] QʃtXN[[hꍇ̂PʖڃXN[̉𑜓x(c) */
    static pixcoord DUAL_VIEW_FULL_SCREEN1_HEIGHT;
    /** [r] QʃtXN[[hꍇ̂QʖڃXN[̉𑜓x() */
    static pixcoord DUAL_VIEW_FULL_SCREEN2_WIDTH;
    /** [r] QʃtXN[[hꍇ̂QʖڃXN[̉𑜓x(c) */
    static pixcoord DUAL_VIEW_FULL_SCREEN2_HEIGHT;
    /** [r/w] \̈ŁARENDER_TARGET_BUFFER̃TCŶ܂ܕ\邩ǂB(true=RENDER_TARGET_BUFFERTCY\/false=\̈̓TCY) */
    static bool VIEW_AS_RENDER_TARGET_BUFFER_SIZE;
    /** [r/w] \̈TCYώA\̈AXyNgQ[obt@̏cŌŒɂ邩ǂ(true=Œ/false=ŒɂȂ) */
    static bool FIXED_GAME_VIEW_ASPECT;
    /** [r/w] Qʃ[hAPʖڂƂQʖڂւ邩ǂ */
    static bool SWAP_GAME_VIEW;
    /** [r/w] Pʃ[hQ[\̈AXyNgŒ莞A\̈ꏊw(ꏊeL[̐l) */
    static int SINGLE_VIEW_DRAW_POSITION;
    /** [r/w] Qʃ[hQ[\̈AXyNgŒ莞APʖڂ̕\̈ꏊw(ꏊeL[̐l) */
    static int DUAL_VIEW_DRAW_POSITION1;
    /** [r/w] Qʃ[hQ[\̈AXyNgŒ莞AQʖڂ̕\̈ꏊw(ꏊeL[̐l) */
    static int DUAL_VIEW_DRAW_POSITION2;
    /** [r/w] AXyNgŒ̏ꍇAQ[\̈̉旦iPʖځj */
    static double VIEW1_WIDTH_RATIO;
    /** [r/w] AXyNgŒ̏ꍇAQ[\̈̍旦iPʖځj */
    static double VIEW1_HEIGHT_RATIO;
    /** [r/w] AXyNgŒ̏ꍇAQ[\̈̉旦iQʖځj */
    static double VIEW2_WIDTH_RATIO;
    /** [r/w] AXyNgŒ̏ꍇAQ[\̈̍旦iQʖځj */
    static double VIEW2_HEIGHT_RATIO;

    /** [r/w] Q[\̈AXyNgŒ莞AQ[\̈O̔wiF */
    static std::string BORDER_COLOR;
    /** [r/w] Q[\̈̔wiF */
    static std::string BG_COLOR;
    /** [r/w] }X^[{[(0`100) */
    static int MASTER_VOLUME;
    /** [r/w] BGM {[(0`100) */
    static int BGM_VOLUME;
    /** [r/w] SoundEffect {[(0`100) */
    static int SE_VOLUME;
    /** [r/w] SEő哯(1`64) */
    static int MAX_SE_AT_ONCE;
    /** [r/w] SE`܂ł́AŒጻKvȃt[ */
    static int MAX_SE_DELAY;

    /** [r] bVf̒`t@C(Xt@C)̊i[fBNg */
    static std::string DIRNAME_RESOURCE_SKIN_XXX_MESH;
    /** [r] 2DXvCgf̒`t@C(sprx)̊i[fBNg */
    static std::string DIRNAME_RESOURCE_SKIN_XXX_SPRITE;
    /** [r] eNX`t@C̊i[fBNg */
    static std::string DIRNAME_RESOURCE_SKIN_XXX_TEXTURE;
    /** [r] GtFNgt@C(fxt@C)̊i[fBNg */
    static std::string DIRNAME_RESOURCE_SKIN_XXX_EFFECT;
    /** [r] BGMt@C(oggt@C)̊i[fBNg */
    static std::string DIRNAME_RESOURCE_SKIN_XXX_OGG;
    /** [r] SoundEffectt@C(wavet@C)̊i[fBNg */
    static std::string DIRNAME_RESOURCE_SKIN_XXX_WAVE;

    /** [r] GtFNgt@C(fxt@C)sɃRpC邩ǂ */
    static bool REALTIME_EFFECT_COMPILE;

    /** [r] sȏꍇɑɓ\teNX`t@C */
    static std::string ILLIGAL_TEXTURE;
    /** [r] sȏꍇɑɓ\t}bveNX`t@C */
    static std::string ILLIGAL_CUBEMAP_TEXTURE;
    /** [r] ꍇɓ\t锒ñeNX` */
    static std::string WHITE_TEXTURE;
    /** [r] AABox蔻vf\p̃f */
    static std::string COLI_AAB_MODEL;
    /** [r] AAPrism蔻vf\p̃f */
    static std::string COLI_AAPRISM_MODEL;
    /** [r] ̓蔻vf\p̃f */
    static std::string COLI_SPHERE_MODEL;

    ////// ȉ́ALvpeB琶ǂݏopvpeB ////////

    /** [r] bVf̒`t@C(Xt@C)̊i[fBNg(0:default/1:[U[/2:Jg) */
    static std::string DIR_MESH_MODEL[3];
    /** [r] 2DXvCgf̒`t@C(sprx)̊i[fBNg(0:default/1:[U[/2:Jg) */
    static std::string DIR_SPRITE_MODEL[3];
    /** [r] eNX`t@C̊i[fBNg(0:default/1:[U[/2:Jg) */
    static std::string DIR_TEXTURE[3];
    /** [r] GtFNgt@C(fxt@C)̊i[fBNg(0:default/1:[U[/2:Jg) */
    static std::string DIR_EFFECT[3];
    /** [r] BGMt@C(oggt@C)̊i[fBNg(0:default/1:[U[/2:Jg) */
    static std::string DIR_OGG[3];
    /** [r] SoundEffectt@C(wavet@C)̊i[fBNg(0:default/1:[U[/2:Jg) */
    static std::string DIR_WAVE[3];
    /** [r] PʃtXN[[hꍇ̃XN[̕␳O𑜓x() */
    static pixcoord SINGLE_VIEW_FULL_SCREEN_WIDTH_BK;
    /** [r] PʃtXN[[hꍇ̃XN[̕␳O𑜓x(c) */
    static pixcoord SINGLE_VIEW_FULL_SCREEN_HEIGHT_BK;
    /** [r] QʃtXN[[hꍇ̂PʖڃXN[̕␳O𑜓x() */
    static pixcoord DUAL_VIEW_FULL_SCREEN1_WIDTH_BK;
    /** [r] QʃtXN[[hꍇ̂PʖڃXN[̕␳O𑜓x(c) */
    static pixcoord DUAL_VIEW_FULL_SCREEN1_HEIGHT_BK;
    /** [r] QʃtXN[[hꍇ̂QʖڃXN[̕␳O𑜓x() */
    static pixcoord DUAL_VIEW_FULL_SCREEN2_WIDTH_BK;
    /** [r] QʃtXN[[hꍇ̂QʖڃXN[̕␳O𑜓x(c) */
    static pixcoord DUAL_VIEW_FULL_SCREEN2_HEIGHT_BK;

public:
    static void load(std::string prm_properties_filename); //shadows
    static void clean();                                   //shadows
};

}
#endif /*GGAFDXCORE_GGAFDXPROPERTIES_H_*/

