#ifndef GGAFDXCORE_GGAFDXMODEL_H_
#define GGAFDXCORE_GGAFDXMODEL_H_
#include "GgafDxCommonHeader.h"
#include "jp/ggaf/core/GgafObject.h"

#include <d3d9.h>
#include <d3dx9.h>

namespace GgafDxCore {

/**
 * fNX.
 * L(AN^[)̌`FȂǂێNXłB<BR>
 * @version 1.00
 * @since 2008/02/21
 * @author Masatoshi Tsuge
 */
class GgafDxModel : public GgafCore::GgafObject {
    friend class GgafDxModelManager;

public:
    class VERTEX_3D_BASE {
    public:
        float x, y, z;    // _W
        float nx, ny, nz; // @
    };


    /** [r]ID */
    int _id;
    /** [r]ő\`ZbgiLN^j*/
    int _set_num;
    /** [r]f`̎ʖB(50܂) */
    char* _model_name;
    /** [r]fCX^X */
    uint32_t _obj_model;
    /** [r]}eAz */
    D3DMATERIAL9* _paMaterial_default;
    /** [r]}eA */
    DWORD _num_materials;

    /** [rw]f̋EaBʊOɗp */
    FLOAT _bounding_sphere_radius;
    /** [r]_ŋx (0.0 <= _power_blink <= 1.0)BGgafDxTextureBlinkerɂ葀삷邱 */
    FLOAT _power_blink;
    /** [r]_őΏRGBl(0.0 <= tex2D()rgb̉ꂩ <= 1.0)BGgafDxTextureBlinkerɂ葀삷邱 */
    FLOAT _blink_threshold;
    //_blink_threshold = 1.0 Ǝw肵ꍇAPStex2D()̃TvOJ[
    //r,g,b ꂩ >= 1.0  ̏ꍇA_power_blink{̐F(rgb)Z
    //[rEX̃L̐Ԃ_ł̂悤ȂƂߍ쐬B

    /** [r]eNX`RlNVz */
    GgafDxTextureConnection** _papTextureConnection;
    /** [r]_őxIuWFNg */
    GgafDxTextureBlinker* const _pTexBlinker;
    /** [r]GgafDxTextureBlinkerpJE^[ */
    frame _blinker_frames;

    /** [r/w]f̃XyL[͈̔́in[txNgE@ςg_specularj */
    float _specular;
    /** [r/w]f̃XyL[̋xiŜ̔{A0.0ȊOݒ肷ƃXyLLɂȂj */
    float _specular_power;

    /** [r]fPʂ̏sς݂ǂ(draw`FbNύX) */
    bool _is_init_model;

    UINT _num_pass;

public:
    /**
     * RXgN^<BR>
     * @param prm_model_name f`̎ʖB".x"ǉƒ`Xt@CɂȂB
     */
    explicit GgafDxModel(char* prm_model_name);

    char* getName(){
        return _model_name;
    }

    /**
     * FxƁAΏېFlݒ .
     * ΏېFlƂ́AFxe^Ώۂ̃eNX`̐F̋łB<BR>
     * sNZVF[_[ɂāA<BR>
     * E܂ł̌vZFieNX`⃉Cglς݁jEEE colOut.rgba<BR>
     * EeNX`̐F EEE colTex.rgba<BR>
     * EΏېFl EEE g_tex_blink_threshold<BR>
     * E݂̐Fxl EEE g_tex_blink_power<BR>
     * ƂꍇAȉ̗lȏsȂĂ܂B<BR>
     * <code><pre>
     * <BR>
     * if (colTex.r >= g_tex_blink_threshold || colTex.g >= g_tex_blink_threshold || colTex.b >= g_tex_blink_threshold) {
     *     colOut *= g_tex_blink_power; //ă{|B_łڗB
     * }
     * </pre></code>
     * [rEX̒n㕨̐Ԃ_ł̂悤ȃGtFNgȒPɎ邽߂ɎEE(ɺ
     * @param prm_power_blink Fxl1 (̐ ` 0: ` 1.0:{x ` )
     * @param prm_blink_threshold FxleΏېFl (0.0 ` 1.0)
     */
    void setBlinkPower(float prm_power_blink, float prm_blink_threshold) {
        _power_blink = prm_power_blink;
        _blink_threshold = prm_blink_threshold;
    }

    /**
     * Fxl݂̂ݒ .
     * @param prm_power_blink Fxl1 (̐ ` 0: ` 1.0:{x ` )
     */
    void setBlinkPower(float prm_power_blink) {
        _power_blink = prm_power_blink;
    }
    /**
     * FxfΏۂ̐Flݒ .
     * @param prm_blink_threshold FxleΏېFl (0.0 ` 1.0)
     */
    void setBlinkThreshold(float prm_blink_threshold) {
        _blink_threshold = prm_blink_threshold;
    }
    /**
     * Fxl擾 .
     * @return Fxl
     */
    float getBlinkPower() {
        return _power_blink;
    }

    /**
     * f̃XyL[xݒ .
     * ̈ 0 ȊO̐lݒ肷ƁAXyL[LɂȂ܂B
     * ̂悤ɐݒ肷ƃXyL[𖳌ɏo܂BiftHg̓XyL[𖳌j
     * setSpecular(0, 0)
     * @param prm_specular f̃XyL[͈̔́in[txNgE@ςg_specularj
     * @param prm_specular_power f̃XyL[̋xiŜ̔{A0.0ȊOݒ肷ƃXyLLɂȂj
     */
    virtual void setSpecular(float prm_specular, float prm_specular_power) {
        _specular = prm_specular;
        _specular_power = prm_specular_power;
    }


    inline GgafDxTextureBlinker* getTexBlinker() {
        return _pTexBlinker;
    }

    /**
     * f` .
     * ʃNXŃf`惍WbNĉB
     * @param prm_pActor_target `悷郂f̃AN^[
     * @param prm_draw_set_num `悷郂f̃Zbg
     * @return
     */
    virtual HRESULT draw(GgafDxDrawableActor* prm_pActor_target, int prm_draw_set_num = 1) = 0;

    /**
     * }eÃeNX`ւĐ؂ւB .
     * \߃fɕ̃eNX`(}eA)o^ĒuKvB<BR>
     * ̓Iɂ X t@Cŗ\ߕ}eAGgieNX`jĂB<BR>
     * @param prm_texture0 \߃fɕ̃eNX`̐؂ւ̃eNX`ID
     *                    iGgafDxTextureManager ɃGgĂ鎯ʕj
     */
    virtual void swapTopTextureOrder(const char* prm_texture0);

    /**
     * fč\z܂.
     */
    virtual void restore() = 0;

    /**
     * f܂.
     */
    virtual void release() = 0;

    /**
     * foCXXgR[obN
     */
    virtual void onDeviceLost() = 0;

    /**
     * fXgN^<BR>
     * deletêGgafDxModelManagerł<BR>
     */
    virtual ~GgafDxModel(); //fXgN^
};

}
#endif /*GGAFDXCORE_GGAFDXMODEL_H_*/
