#ifndef GGAFDXCORE_GGAFDXMORPHMESHMODEL_H_
#define GGAFDXCORE_GGAFDXMORPHMESHMODEL_H_
#include "GgafDxCommonHeader.h"
#include "jp/ggaf/dxcore/model/GgafDxModel.h"

namespace GgafDxCore {

/**
 * GgafDxMorphMeshModelp̃fNX.
 * GgafDxMorphMeshModel  GgafDxMeshModel ̕`悷@\ɉA[tAj[V@\L郂fłB<BR>
 * <b>̃f ( prm_model_name ) ̗^Ɠǂݍ܂Xt@Cɂ</b><BR>
 * ၄<BR>
 * <table border=1>
 * <tr>
 * <th>prm_model_name</th>
 * <th>vC}bV Xt@C</th>
 * <th>[t^[Qbg Xt@C</th>
 * </tr>
 * <tr>
 * <td>"M/0/ball"</td>
 * <td>ball_0.x</td>
 * <td></td>
 * </tr>
 * <tr>
 * <td>"M/1/ball"</td>
 * <td>ball_0.x</td>
 * <td>ball_1.x</td>
 * </tr>
 * <tr>
 * <td>"M/2/ball"</td>
 * <td>ball_0.x</td>
 * <td>ball_1.x, ball_2.x</td>
 * </tr>
 * <tr>
 * <td>"M/3/ball"</td>
 * <td>ball_0.x</td>
 * <td>ball_1.x, ball_2.x, ball_3.x</td>
 * </tr>
 * <tr>
 * <td>"M/6/ball"</td>
 * <td>ball_0.x</td>
 * <td>ball_1.x, ball_2.x, ball_3.x,EEEball_6.x</td>
 * </tr>
 * </table>
 * @version 1.00
 * @since 2009/05/08
 * @author Masatoshi Tsuge
 */
class GgafDxMorphMeshModel : public GgafDxModel {
    friend class GgafDxModelManager;

public:
    struct INDEXPARAM {
        UINT MaterialNo;
        INT BaseVertexIndex;
        UINT MinIndex;
        UINT NumVertices;
        UINT StartIndex;
        UINT PrimitiveCount;
    };

    /** vC}bV̒_tH[}bg` */
    class VERTEX_PRIMARY : public GgafDxModel::VERTEX_3D_BASE {
    public:
        DWORD color;      // _̐Fiݖgpj
        float tu, tv;     // eNX`W
    };

    /** [t^[QbgbV̒_tH[}bg` */
    class VERTEX_MORPH : public GgafDxModel::VERTEX_3D_BASE {
    public:
    };

    /** [t^[Qbg */
    int _morph_target_num;
    /** VF[_[͒_tH[}bg */
    LPDIRECT3DVERTEXDECLARATION9 _pIDirect3DVertexDeclaration9;
    /** _obt@ivC}j */
    LPDIRECT3DVERTEXBUFFER9 _pVertexBuffer_primary;
    /** _obt@̔zivf[t^[Qbgj */
    LPDIRECT3DVERTEXBUFFER9* _paIDirect3DVertexBuffer9_morph;

    /** CfbNXobt@ivC}̂݁j */
    LPDIRECT3DINDEXBUFFER9 _pIndexBuffer;


    /** _̃TCYivC}j */
    UINT _size_vertices_primary;
    /** 1_̃TCYivC}j */
    UINT _size_vertex_unit_primary;
    /** _̃TCYi[t^[Qbgj */
    UINT _size_vertices_morph;
    /** 1_̃TCYi[t^[Qbgj */
    UINT _size_vertex_unit_morph;

    /** DrawIndexedPrimitive`p[^[ivC}̂݁j */
    INDEXPARAM* _paIndexParam;
    /** }eAސivC}̂݁j */
    UINT _material_list_grp_num;

    /** _obt@̎ʂRs[̒_zivC}j */
    VERTEX_PRIMARY* _paVtxBuffer_org_primary;
    /** _obt@̎ʂRs[̒_z̃[t^[Qbgz */
    VERTEX_MORPH**  _papaVtxBuffer_org_morph;
    /** CfbNXobt@̎ʂRs[ivC}̂݁j */
    WORD* _paIdxBuffer_org;

    /** Paul񃂃fivfvC}{[t^[Qbgj */
    Frm::Model3D** _papModel3D;
    /** Paul񃁃bVivfvC}{[t^[Qbgj */
    Frm::Mesh** _papMeshesFront;

public:
    /**
     * RXgN^<BR>
     * @param prm_model_name f`̎ʖ
     */
    GgafDxMorphMeshModel(char* prm_model_name);

    virtual HRESULT draw(GgafDxDrawableActor* prm_pActor_target, int prm_draw_set_num = 1) override;

    virtual void restore() override;

    virtual void onDeviceLost() override;

    void release() override;

    void changeVertexAlpha(int prm_vertex_alpha);

    /**
     * fXgN^<BR>
     */
    virtual ~GgafDxMorphMeshModel(); //fXgN^
};

}
#endif /*GGAFDXCORE_GGAFDXMORPHMESHMODEL_H_*/
