#ifndef GGAFLIB_REFRACTIONLASERCHIP_H_
#define GGAFLIB_REFRACTIONLASERCHIP_H_
#include "GgafLibCommonHeader.h"
#include "jp/ggaf/lib/actor/laserchip/LaserChip.h"

namespace GgafLib {

/**
 * ˁi܁j[U[p|C̃`bv .
 * ˁi܁j[U[Ȃǂǂƕ\Ă邪Amɂ <BR>
 * EˍWŒiˌW͒ʏ͈ړsj <BR>
 * EړAx͐擪`bv݂̂߁Ac`bv͒PɒǏ]<BR>
 * Eړ͒iAAԊuňړω <BR>
 * ƌׂA_CAX̃{X̑i[U[ƌׂAȊB<BR>
 * f|Wgo^Oconfig()Őݒ肵ĂB<BR>
 * Kuroko ňړ܂Bdispatch() AW KurokoixEjݒ肵ĉB<BR>
 * @version 1.00
 * @since 2010/01/19
 * @author Masatoshi Tsuge
 */
class RefractionLaserChip : public LaserChip {
    friend class LaserChipDepository;

private:
    /** [r]()܊Jnt[ */
    frame _frame_refraction_enter;
    /** [r]܏It[ */
    frame _frame_refraction_out;
    /** [r]܂ɋܒiړĂȂj̏ꍇtrue */
    bool _is_refracting;
    /** [r]݂̋܉ */
    int _cnt_refraction;

    /** 擱`bvi{̐擪`bvjtO */
    bool _is_leader; //{̐擪`bvƂ́A[U[ړɂĔɂ킩擪`bvł͖ƂӖB;
    int _begining_x;
    int _begining_y;
    int _begining_z;
    angle _begining_rx;
    angle _begining_ry;
    angle _begining_rz;
    int _prev_x;
    int _prev_y;
    int _prev_z;
    angle _prev_rx;
    angle _prev_ry;
    angle _prev_rz;

    bool _prev_is_refracting;
    GgafDxCore::GgafDxDrawableActor* _prev_pRefractionEffect;

    /** ܃GtFNgAN^[̃f|WgiV[ς݂ł邱Ɓj */
    GgafCore::GgafActorDepository* _pDepo_refraction_effect;
    GgafDxCore::GgafDxDrawableActor* _pRefractionEffect;

public:
    /** [r]ŏIIȋ܉ */
    int _num_refraction;
    /** [r]iJn(܏I)`i`iI(܊Jn)Ãt[(>= 1) */
    frame _frame_between_refraction;
    /** [r]܎(iI(܊Jn)`~`iJn(܏I))̒ؒ߃t[(>= 1) */
    frame _frame_standstill_refraction;
    /** [r]ˊJnWŒ肩ۂ(true:ŒAĂь̍W㏑āAŏ[0]̍Wɋ㏑/false:ŒBXN[V[z̏ꍇ false ǂ */
    bool _is_fix_begin_pos;

public:
    RefractionLaserChip(const char* prm_name, const char* prm_model, GgafCore::GgafStatus* prm_pStat=nullptr);

    /**
     * tNV[U[` .
     * @param prm_num_refraction ܂邩
     * @param prm_frame_between_refraction iJn(܏I)`i`iI(܊Jn)Ãt[(>= 1)
     * @param prm_frame_standstill_refraction ܎(iI(܊Jn)`~`iJn(܏I))̒ؒ߃t[(>= 1)
     * @param prm_is_fix_beginning_pos true:[U[ˌ́A擪[U[`bv̍WɌŒ肳B^false:ꂼ̃[U[`bv̍WɈˑ
     * @param prm_pDepo_refraction_effect ܎̃GtFNgAN^[̃f|Wg(̏ꍇnullptr)
     */
    virtual void config(int prm_num_refraction,
                        frame prm_frame_between_refraction,
                        frame prm_frame_standstill_refraction,
                        bool prm_is_fix_begin_pos,
                        GgafCore::GgafActorDepository* prm_pDepo_refraction_effect);

    virtual void onCreateModel() override {}

    virtual void initialize() override {}

    /**
     * [U[`bvWvZ .
     * Ǝݒ肵ꍇApĕʃNX쐬AI[o[ChĂB
     * ̍ ́A{NX processBehavior() \bhĂяoĂB
     */
    virtual void processBehavior() override;

    virtual void processJudgement() override {}

    virtual void processSettlementBehavior() override;

    virtual void onCatchEvent(hashval prm_no, void* prm_pSource) override {}

    /**
     * 擪`bṽ[U[̒iI`܊Jn̏ .
     * @param prm_num_refraction ܃JEg(ڂ̋܊Jn)(0`)
     */
    virtual void onRefractionBegin(int prm_num_refraction) = 0;

    /**
     * 擪`bṽ[U[̂ߌ܌I`iJn̏ .
     * ۂɂ݂͑Ȃ0ڂ̋܏IX^[gB
     * @param prm_num_refraction ܃JEg(ڂ̋܏I)(0`)
     */
    virtual void onRefractionFinish(int prm_num_refraction) = 0;

    /**
     * [U[`bvo .
     * Ǝݒ肵ꍇApĕʃNX쐬AI[o[ChĂB
     * ̍ ́A{NX onActive() \bhĂяoĂB
     */
    virtual void onActive() override;

    /**
     * [U[`bv .
     * Ǝݒ肵ꍇApĕʃNX쐬AI[o[ChĂB
     * ̍ ́A{NX onInactive() \bhĂяoĂB
     */
    virtual void onInactive() override;

    virtual ~RefractionLaserChip();

};

}
#endif /*GGAFLIB_HOMINGLASERCHIP_H_*/

