#include "GgafEffectConst.fxh" 
////////////////////////////////////////////////////////////////////////////////
// GgafCuAGgafDxSpriteModelpVF[_[
//
// author : Masatoshi Tsuge
// date:2009/03/06 
////////////////////////////////////////////////////////////////////////////////

float4x4 g_matWorld;  //Worldϊs
float4x4 g_matView;   //Viewϊs
float4x4 g_matProj;   //ˉeϊs
float4 g_colMaterialDiffuse;
float g_offset_u; //eNX`UW
float g_offset_v; //eNX`VW
float g_tex_blink_power;   
float g_tex_blink_threshold;
float g_alpha_master;
float g_zf;
float g_far_rate;

//soWX^̃Tvg(ŒpCvCɃZbgꂽeNX`VF[_[Ŏg)
sampler MyTextureSampler : register(s0);

//_VF[_[Ao͍\
struct OUT_VS
{
    float4 posModel_Proj    : POSITION;
	float2 uv     : TEXCOORD0;
};


///////////////////////////////////////////////////////////////////////////

//XvCgW_VF[_[
OUT_VS GgafDxVS_DefaultSprite(
      float4 prm_posModel_Local    : POSITION,     // f̒_
      float2 prm_uv     : TEXCOORD0     // f̒_UV
) {
	OUT_VS out_vs = (OUT_VS)0;

	//_vZ
	float4 posModel_World = mul(prm_posModel_Local, g_matWorld ); // Worldϊ
	float4 posModel_View = mul(posModel_World, g_matView );       // Viewϊ
	float4 posModel_Proj = mul(posModel_View, g_matProj);         // ˉeϊ
	out_vs.posModel_Proj = posModel_Proj;                         // o͂ɐݒ
    if (g_far_rate > 0.0) {
        if (out_vs.posModel_Proj.z > g_zf*g_far_rate) {   
            out_vs.posModel_Proj.z = g_zf*g_far_rate; //{OZłA`邽0.9ȓɏ㏑A
        }
    } 

	//UṼItZbg(p^[ԍɂ鑝)Z
	out_vs.uv.x = prm_uv.x + g_offset_u;
	out_vs.uv.y = prm_uv.y + g_offset_v;
//    if (out_vs.posModel_Proj.z > g_zf*0.98) {   
//        out_vs.posModel_Proj.z = g_zf*0.98; //{OZłA`邽0.9ȓɏ㏑A
//    }
	return out_vs;
}


//XvCgWsNZVF[_[
float4 GgafDxPS_DefaultSprite(
	float2 prm_uv	  : TEXCOORD0
) : COLOR  {
	//߂F
	float4 colOut = tex2D( MyTextureSampler, prm_uv) ; 
	if (colOut.r >= g_tex_blink_threshold || colOut.g >= g_tex_blink_threshold || colOut.b >= g_tex_blink_threshold) {
		colOut *= g_tex_blink_power; //ă{|B_łڗB
	}   
    colOut *= g_colMaterialDiffuse;
    colOut.a *= g_alpha_master; 
	return colOut;
}

float4 PS_Flush(
	float2 prm_uv	  : TEXCOORD0
) : COLOR  {
	float4 colOut = tex2D( MyTextureSampler, prm_uv)  * FLUSH_COLOR;
    colOut *= g_colMaterialDiffuse;
    colOut.a *= g_alpha_master; 
	return colOut;
}

//eNjbNFDefaultSpriteTechnique
//y@\z
//GgafDxSpriteModelpWVF[_[
//yTvz
//|i[XvCgj`悷BCgȂǂ̉Ae͖B
technique DefaultSpriteTechnique
{
	pass P0 {
		AlphaBlendEnable = true;
        //SeparateAlphaBlendEnable = true;
		SrcBlend  = SrcAlpha;
		DestBlend = InvSrcAlpha;
        //SrcBlendAlpha = One;      //default
        //DestBlendAlpha = Zero;    //default
		BlendOpAlpha = Add;
		VertexShader = compile VS_VERSION GgafDxVS_DefaultSprite();
		PixelShader  = compile PS_VERSION GgafDxPS_DefaultSprite();
	}
}

technique DestBlendOne
{
	pass P0 {
		AlphaBlendEnable = true;
        //SeparateAlphaBlendEnable = true;
		SrcBlend  = SrcAlpha;   
		DestBlend = One; //Z
        //SrcBlendAlpha = One;      //default
        //DestBlendAlpha = Zero;    //default
		BlendOpAlpha = Add;
		VertexShader = compile VS_VERSION GgafDxVS_DefaultSprite();
		PixelShader  = compile PS_VERSION GgafDxPS_DefaultSprite();
	}
}

technique Flush
{
	pass P0 {
		AlphaBlendEnable = true;
        //SeparateAlphaBlendEnable = true;
		SrcBlend  = SrcAlpha;
		DestBlend = InvSrcAlpha;
        //SrcBlendAlpha = One;      //default
        //DestBlendAlpha = Zero;    //default
		BlendOpAlpha = Add;
		VertexShader = compile VS_VERSION GgafDxVS_DefaultSprite();
		PixelShader  = compile PS_VERSION PS_Flush();
	}
}
